--- encoder/analyse.c
+++ encoder/analyse.c
@@ -306,7 +306,7 @@
 /* Max = 4 */
 static void predict_16x16_mode_available( unsigned int i_neighbour, int *mode, int *pi_count )
 {
-    if( i_neighbour & MB_TOPLEFT )
+    if( (i_neighbour & (MB_LEFT|MB_TOP)) == (MB_LEFT|MB_TOP) )
     {
         /* top and left avaible */
         *mode++ = I_PRED_16x16_V;
@@ -340,7 +340,7 @@
 /* Max = 4 */
 static void predict_8x8chroma_mode_available( unsigned int i_neighbour, int *mode, int *pi_count )
 {
-    if( i_neighbour & MB_TOPLEFT )
+    if( (i_neighbour & (MB_LEFT|MB_TOP)) == (MB_LEFT|MB_TOP) )
     {
         /* top and left avaible */
         *mode++ = I_PRED_CHROMA_V;
